Index: trunk/SophyaLib/Samba/spheregorski.cc
===================================================================
--- trunk/SophyaLib/Samba/spheregorski.cc	(revision 745)
+++ trunk/SophyaLib/Samba/spheregorski.cc	(revision 746)
@@ -338,5 +338,5 @@
 //++
 template<class T>
-void SphereGorski<T>::GetThetaSlice(int_4 index,double& theta,TVector<double>& phi,TVector<T>& value) const 
+void SphereGorski<T>::GetThetaSlice(int_4 index, r_8& theta,TVector<r_8>& phi,TVector<T>& value) const 
 
 //    For a theta-slice with index 'index', return : 
@@ -379,5 +379,5 @@
 
 template<class T>
-void SphereGorski<T>::GetThetaSlice(int_4 sliceIndex,double& theta, double& phi0, TVector<int>& pixelIndices,TVector<T>& value) const 
+void SphereGorski<T>::GetThetaSlice(int_4 sliceIndex,r_8& theta, r_8& phi0, TVector<int_4>& pixelIndices,TVector<T>& value) const 
 
 //    For a theta-slice with index 'sliceIndex', return : 
Index: trunk/SophyaLib/Samba/spheregorski.h
===================================================================
--- trunk/SophyaLib/Samba/spheregorski.h	(revision 745)
+++ trunk/SophyaLib/Samba/spheregorski.h	(revision 746)
@@ -98,5 +98,5 @@
     a vector containing the corresponding values of pixels 
 */
-void GetThetaSlice(int_4 index,double& theta,TVector<double>& phi,TVector<T>& value) const;
+void GetThetaSlice(int_4 index,r_8& theta,TVector<r_8>& phi,TVector<T>& value) const;
 /*!   For a theta-slice with index 'index', return : 
 
@@ -111,5 +111,5 @@
     a vector containing the corresponding values of pixels 
 */
- void GetThetaSlice(int_4 sliceIndex,double& theta, double& phi0, TVector<int>& pixelIndices,TVector<T>& value) const ;
+ void GetThetaSlice(int_4 sliceIndex,r_8& theta, r_8& phi0, TVector<int_4>& pixelIndices,TVector<T>& value) const ;
 
 /* Return true if teta,phi in map  */
Index: trunk/SophyaLib/Samba/spherethetaphi.cc
===================================================================
--- trunk/SophyaLib/Samba/spherethetaphi.cc	(revision 745)
+++ trunk/SophyaLib/Samba/spherethetaphi.cc	(revision 746)
@@ -537,5 +537,5 @@
 //++
 template <class T>
-void SphereThetaPhi<T>::GetThetaSlice(int_4 index,double& theta, TVector<double>& phi, TVector<T>& value) const 
+void SphereThetaPhi<T>::GetThetaSlice(int_4 index,r_8& theta, TVector<r_8>& phi, TVector<T>& value) const 
 
 //    For a theta-slice with index 'index', return : 
@@ -570,5 +570,5 @@
 //++
 template <class T>
-void SphereThetaPhi<T>::GetThetaSlice(int_4 index,double& theta, double& phi0,TVector<int>& pixelIndices, TVector<T>& value) const 
+void SphereThetaPhi<T>::GetThetaSlice(int_4 index,r_8& theta, r_8& phi0,TVector<int_4>& pixelIndices, TVector<T>& value) const 
 
 //    For a theta-slice with index 'index', return : 
Index: trunk/SophyaLib/Samba/spherethetaphi.h
===================================================================
--- trunk/SophyaLib/Samba/spherethetaphi.h	(revision 745)
+++ trunk/SophyaLib/Samba/spherethetaphi.h	(revision 746)
@@ -141,5 +141,5 @@
     a vector containing the corresponding values of pixels 
 */
-void GetThetaSlice(int_4 index,double& theta,TVector<double>& phi,TVector<T>& value) const; 
+void GetThetaSlice(int_4 index,r_8& theta,TVector<r_8>& phi,TVector<T>& value) const; 
 
 /*!   For a theta-slice with index 'index', return : 
@@ -155,5 +155,5 @@
     a vector containing the corresponding values of pixels 
 */
- void GetThetaSlice(int_4 index,double& theta, double& phi0,TVector<int>& pixelIndices, TVector<T>& value) const ;
+ void GetThetaSlice(int_4 index, r_8& theta, r_8& phi0,TVector<int_4>& pixelIndices, TVector<T>& value) const ;
 
 
Index: trunk/SophyaLib/Samba/sphericalmap.h
===================================================================
--- trunk/SophyaLib/Samba/sphericalmap.h	(revision 745)
+++ trunk/SophyaLib/Samba/sphericalmap.h	(revision 746)
@@ -36,6 +36,6 @@
 virtual void Resize(int m)=0;
 virtual uint_4 NbThetaSlices() const=0;
-virtual void GetThetaSlice(int index,double& theta, TVector<double>& phi, TVector<T>& value) const=0; 
-virtual void GetThetaSlice(int_4 sliceIndex,double& theta, double& phi0, TVector<int>& pixelIndices,TVector<T>& value) const=0 ;
+virtual void GetThetaSlice(int_4 index,r_8& theta, TVector<r_8>& phi, TVector<T>& value) const=0; 
+virtual void GetThetaSlice(int_4 sliceIndex, r_8& theta, r_8& phi0, TVector<int_4>& pixelIndices,TVector<T>& value) const=0 ;
 };
 #endif
Index: trunk/SophyaLib/Samba/sphericaltransformserver.cc
===================================================================
--- trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 745)
+++ trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 746)
@@ -63,5 +63,5 @@
 
   // pour chaque tranche en theta
-  for (int ith = 0; ith < map.NbThetaSlices();ith++)
+  for (int_4 ith = 0; ith < map.NbThetaSlices();ith++)
     {
       int_4 nph;
@@ -195,5 +195,5 @@
   //sortie.ReSize(nph);
   TVector< complex<T> > sortie(nph);
-  //  sortie.SetTemp(true);
+  sortie.SetTemp(true);
 
   fftIntfPtr_-> FFTBackward(data, sortie);
@@ -274,5 +274,5 @@
   //sortie.ReSize(nph);
   TVector<T> sortie;
-  //  sortie.SetTemp(true);
+  sortie.SetTemp(true);
 
   fftIntfPtr_-> FFTBackward(data, sortie);
@@ -295,8 +295,7 @@
   TVector< complex<T> > phase(nmmax+1);
   Alm<T> alm;
-  //  alm.SetTemp(true);
+  alm.SetTemp(true);
   alm.ReSizeToLmax(nlmax);
-  //  cout << " nombre de tranches " << map.NbThetaSlices() << endl;
-  for (int ith = 0; ith < map.NbThetaSlices(); ith++)
+  for (int_4 ith = 0; ith < map.NbThetaSlices(); ith++)
     {
       int_4 nph;
@@ -320,6 +319,6 @@
 	  // for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(data(kk),(T)0.);
 
-	  //  phase = CFromFourierAnalysis(nlmax,nmmax,datain,phi0);
-	  phase = CFromFourierAnalysis(nlmax,nmmax,data,phi0);
+	  //  phase = CFromFourierAnalysis(nmmax,datain,phi0);
+	  phase = CFromFourierAnalysis(nmmax,data,phi0);
 
 	}
@@ -345,5 +344,5 @@
 }
 template<class T>
-TVector< complex<T> > SphericalTransformServer<T>::CFromFourierAnalysis(int_4 nlmax,int_4 nmmax, const TVector<complex<T> >datain, r_8 phi0) const
+TVector< complex<T> > SphericalTransformServer<T>::CFromFourierAnalysis(int_4 nmmax, const TVector<complex<T> >datain, r_8 phi0) const
 {
   /*=======================================================================
@@ -382,5 +381,5 @@
 //&&&&&&&&& nouvelle version
 template<class T>
-TVector< complex<T> > SphericalTransformServer<T>::CFromFourierAnalysis(int_4 nlmax,int_4 nmmax, const TVector<T> datain, r_8 phi0) const
+TVector< complex<T> > SphericalTransformServer<T>::CFromFourierAnalysis(int_4 nmmax, const TVector<T> datain, r_8 phi0) const
 {
   //=======================================================================
@@ -549,5 +548,5 @@
       throw SzMismatchError("SphericalTransformServer::DecomposeToAlm: map Q and map U have not same size ");
     }
-  for (int ith = 0; ith < mapq.NbThetaSlices(); ith++)
+  for (int_4 ith = 0; ith < mapq.NbThetaSlices(); ith++)
     {
       int_4 nph;
@@ -568,12 +567,12 @@
 	{
 	  //  almFromPM(nph, nlmax, nmmax, phi0, domega, theta, dataq, datau, alme, almb); 
-	  almFromWX(nph, nlmax, nmmax, phi0, domega, theta, dataq, datau, alme, almb); 
-	}
-    }
-}
-
-
-template<class T>
-void SphericalTransformServer<T>::almFromWX(int_4 nph, int_4 nlmax, int_4 nmmax,
+	  almFromWX(nlmax, nmmax, phi0, domega, theta, dataq, datau, alme, almb); 
+	}
+    }
+}
+
+
+template<class T>
+void SphericalTransformServer<T>::almFromWX(int_4 nlmax, int_4 nmmax,
 					 r_8 phi0, r_8 domega, 
 					 r_8 theta, 
@@ -593,11 +592,11 @@
   //  for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),0.);
 
-  // phaseq = CFromFourierAnalysis(nlmax,nmmax,datain,phi0); 
-  phaseq = CFromFourierAnalysis(nlmax,nmmax,dataq,phi0); 
+  // phaseq = CFromFourierAnalysis(nmmax,datain,phi0); 
+  phaseq = CFromFourierAnalysis(nmmax,dataq,phi0); 
 
   // for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(datau(kk),0.);
 
   // phaseu=  CFromFourierAnalysis(nlmax,nmmax,datain,phi0); 
-  phaseu=  CFromFourierAnalysis(nlmax,nmmax,datau,phi0); 
+  phaseu=  CFromFourierAnalysis(nmmax,datau,phi0); 
 
   LambdaWXBuilder lwxb(theta,nlmax,nmmax);
@@ -644,8 +643,8 @@
   for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),datau(kk));
 
-  phasep = CFromFourierAnalysis(nlmax,nmmax,datain,phi0); 
+  phasep = CFromFourierAnalysis(nmmax,datain,phi0); 
 
   for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),-datau(kk));
-  phasem = CFromFourierAnalysis(nlmax,nmmax,datain,phi0); 
+  phasem = CFromFourierAnalysis(nmmax,datain,phi0); 
   LambdaPMBuilder lpmb(theta,nlmax,nmmax);
 	  
@@ -679,5 +678,5 @@
   Bm<complex<T> > b_m_theta_u(nmmax);
 
-  for (int ith = 0; ith < mapq.NbThetaSlices();ith++)
+  for (int_4 ith = 0; ith < mapq.NbThetaSlices();ith++)
     {
       int_4 nph;
@@ -748,5 +747,5 @@
   Bm<complex<T> > b_m_theta_p(nmmax);
   Bm<complex<T> > b_m_theta_m(nmmax);
-  for (int ith = 0; ith < mapq.NbThetaSlices();ith++)
+  for (int_4 ith = 0; ith < mapq.NbThetaSlices();ith++)
     {
       int_4 nph;
@@ -834,7 +833,4 @@
 {
 
-  //  Alm<T> alm;
-  //  almFromCl(alm, Cl, fwhm); 
-  //Alm<T> alm = almFromCl(Cl, fwhm);
   Alm<T> alm(Cl, fwhm);
   GenerateFromAlm(sph,pixelSizeIndex, alm ); 
@@ -846,6 +842,4 @@
 TVector<T>  SphericalTransformServer<T>::DecomposeToCl(const SphericalMap<T>& sph, int_4 nlmax, r_8 cos_theta_cut) const
 {
-  //  Alm<T> alm;
-  //  DecomposeToAlm( sph, alm,nlmax, cos_theta_cut);
     Alm<T> alm=DecomposeToAlm( sph, nlmax, cos_theta_cut);
   // power spectrum
Index: trunk/SophyaLib/Samba/sphericaltransformserver.h
===================================================================
--- trunk/SophyaLib/Samba/sphericaltransformserver.h	(revision 745)
+++ trunk/SophyaLib/Samba/sphericaltransformserver.h	(revision 746)
@@ -10,4 +10,5 @@
 
 
+namespace SOPHYA {
 
 //
@@ -98,9 +99,9 @@
 \f$\sum_{k=0}^{nphi}datain(\theta,\varphi_k)e^{im\varphi_k}\f$ for (mmax+1) values of \f$m\f$ from 0 to mmax.
    */
- TVector< complex<T> > CFromFourierAnalysis(int_4 nlmax,int_4 mmax, 
+ TVector< complex<T> > CFromFourierAnalysis(int_4 mmax, 
 				  const TVector<complex<T> > datain,
 				  r_8 phi0) const;
 /* same as previous one, but with a "datain" which is real (not complex) */
- TVector< complex<T> > CFromFourierAnalysis(int_4 nlmax,int_4 mmax, 
+ TVector< complex<T> > CFromFourierAnalysis(int_4 mmax, 
 			 const TVector<T> datain,  
 				  r_8 phi0) const;
@@ -122,5 +123,5 @@
 
   */
-void almFromWX(int_4 nph, int_4 nlmax, int_4 nmmax, r_8 phi0, 
+void almFromWX(int_4 nlmax, int_4 nmmax, r_8 phi0, 
 	       r_8 domega, r_8 theta, 
 	       const TVector<T>& dataq, const TVector<T>& datau,
@@ -200,4 +201,5 @@
  FFTServerInterface* fftIntfPtr_;
 };
+} // Fin du namespace
 
 