Index: trunk/SophyaLib/NTools/fftservintf.cc
===================================================================
--- trunk/SophyaLib/NTools/fftservintf.cc	(revision 717)
+++ trunk/SophyaLib/NTools/fftservintf.cc	(revision 750)
@@ -18,5 +18,5 @@
 void FFTServerInterface::FFTForward(TVector< complex<r_8> > const &, TVector< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TVector...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TVector...) Unsupported operation !");
 }
 
@@ -24,5 +24,5 @@
 void FFTServerInterface::FFTBackward(TVector< complex<r_8> > const &, TVector< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TVector...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TVector...) Unsupported operation !");
 }
 
@@ -30,5 +30,5 @@
 void FFTServerInterface::FFTForward(TVector< r_8 > const &, TVector< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TVector...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TVector...) Unsupported operation !");
 }
 
@@ -36,5 +36,5 @@
 void FFTServerInterface::FFTBackward(TVector< complex<r_8> > const &, TVector< r_8 > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TVector...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TVector...) Unsupported operation !");
 }
 
@@ -42,5 +42,5 @@
 void FFTServerInterface::FFTForward(TMatrix< complex<r_8> > const &, TMatrix< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TMatrix...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TMatrix...) Unsupported operation !");
 }
 
@@ -48,5 +48,5 @@
 void FFTServerInterface::FFTBackward(TMatrix< complex<r_8> > const &, TMatrix< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TMatrix...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TMatrix...) Unsupported operation !");
 }
 
@@ -54,5 +54,5 @@
 void FFTServerInterface::FFTForward(TMatrix< r_8 > const &, TMatrix< complex<r_8> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TMatrix...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TMatrix...) Unsupported operation !");
 }
 
@@ -60,5 +60,5 @@
 void FFTServerInterface::FFTBackward(TMatrix< complex<r_8> > const &, TMatrix< r_8 > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TMatrix...) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TMatrix...) Unsupported operation !");
 }
 
@@ -69,5 +69,5 @@
 void FFTServerInterface::FFTForward(TVector< complex<r_4> > const &, TVector< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TVector r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TVector r_4 ... ) Unsupported operation !");
 }
 
@@ -75,5 +75,5 @@
 void FFTServerInterface::FFTBackward(TVector< complex<r_4> > const &, TVector< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TVector r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TVector r_4 ... ) Unsupported operation !");
 }
 
@@ -81,5 +81,5 @@
 void FFTServerInterface::FFTForward(TVector< r_4 > const &, TVector< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TVector r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TVector r_4 ... ) Unsupported operation !");
 }
 
@@ -87,5 +87,5 @@
 void FFTServerInterface::FFTBackward(TVector< complex<r_4> > const &, TVector< r_4 > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TVector r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TVector r_4 ... ) Unsupported operation !");
 }
 
@@ -93,5 +93,5 @@
 void FFTServerInterface::FFTForward(TMatrix< complex<r_4> > const &, TMatrix< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TMatrix r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TMatrix r_4 ... ) Unsupported operation !");
 }
 
@@ -99,5 +99,5 @@
 void FFTServerInterface::FFTBackward(TMatrix< complex<r_4> > const &, TMatrix< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TMatrix r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TMatrix r_4 ... ) Unsupported operation !");
 }
 
@@ -105,5 +105,5 @@
 void FFTServerInterface::FFTForward(TMatrix< r_4 > const &, TMatrix< complex<r_4> > &)
 {
-  throw ForbiddenError("FFTServer::FFTForward(TMatrix r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTForward(TMatrix r_4 ... ) Unsupported operation !");
 }
 
@@ -111,5 +111,5 @@
 void FFTServerInterface::FFTBackward(TMatrix< complex<r_4> > const &, TMatrix< r_4 > &)
 {
-  throw ForbiddenError("FFTServer::FFTBackward(TMatrix r_4 ... ) Unsupported operation !");
+  throw NotAvailableOperation("FFTServer::FFTBackward(TMatrix r_4 ... ) Unsupported operation !");
 }
 