Index: trunk/SophyaLib/NTools/fftpackc.h
===================================================================
--- trunk/SophyaLib/NTools/fftpackc.h	(revision 717)
+++ trunk/SophyaLib/NTools/fftpackc.h	(revision 756)
@@ -8,12 +8,12 @@
 #endif
 
-typedef int integer;
-typedef unsigned uinteger;
-typedef char *address;
-typedef short int shortint;
-  // typedef float real;
-  // typedef double doublereal;
-  //typedef struct { float r, i; } complex;
-  //typedef struct { double r, i; } doublecomplex;
+  /* typedef int integer;
+  typedef unsigned uinteger;
+  typedef char *address;
+  typedef short int shortint;
+  typedef float real;
+  typedef double doublereal;
+  typedef struct { float r, i; } complex;
+  typedef struct { double r, i; } doublecomplex;  */
 
 /* typedef int_4 logical;
@@ -24,105 +24,105 @@
 /* ---------------------- */
 
-extern int cfftb_(integer *n, r_4 *c__, r_4 *wsave);
-extern int cfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int cfftf_(integer *n, r_4 *c__, r_4 *wsave);
-extern int cfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int cffti_(integer *n, r_4 *wsave);
-extern int cffti1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int cosqb_(integer *n, r_4 *x, r_4 *wsave);
-extern int cosqb1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
-extern int cosqf_(integer *n, r_4 *x, r_4 *wsave);
-extern int cosqf1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
-extern int cosqi_(integer *n, r_4 *wsave);
-extern int cost_(integer *n, r_4 *x, r_4 *wsave);
-extern int costi_(integer *n, r_4 *wsave);
-extern int ezfft1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int ezfftb_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
-extern int ezfftf_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
-extern int ezffti_(integer *n, r_4 *wsave);
-extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int passb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int passb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int passb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int passb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int passf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int passf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int passf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int passf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int radb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int radb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int radb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int radf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int radf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int radf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int radf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int rfftb_(integer *n, r_4 *r__, r_4 *wsave);
-extern int rfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int rfftf_(integer *n, r_4 *r__, r_4 *wsave);
-extern int rfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int rffti_(integer *n, r_4 *wsave);
-extern int rffti1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int sinqb_(integer *n, r_4 *x, r_4 *wsave);
-extern int sinqf_(integer *n, r_4 *x, r_4 *wsave);
-extern int sinqi_(integer *n, r_4 *wsave);
-extern int sint_(integer *n, r_4 *x, r_4 *wsave);
-extern int sint1_(integer *n, r_4 *war, r_4 *was, r_4 *xh, r_4 *x, int_4 *ifac);
-extern int sinti_(integer *n, r_4 *wsave);
+extern int cfftb_(int_4 *n, r_4 *c__, r_4 *wsave);
+extern int cfftb1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cfftf_(int_4 *n, r_4 *c__, r_4 *wsave);
+extern int cfftf1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cffti_(int_4 *n, r_4 *wsave);
+extern int cffti1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int cosqb_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int cosqb1_(int_4 *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqf_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int cosqf1_(int_4 *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqi_(int_4 *n, r_4 *wsave);
+extern int cost_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int costi_(int_4 *n, r_4 *wsave);
+extern int ezfft1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int ezfftb_(int_4 *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezfftf_(int_4 *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezffti_(int_4 *n, r_4 *wsave);
+extern int passb_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passb2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passb3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passb4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passb5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int passf_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passf2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passf3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passf4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passf5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radb2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radb3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radb4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radb5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radbg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int radf2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radf3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radf4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radf5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radfg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int rfftb_(int_4 *n, r_4 *r__, r_4 *wsave);
+extern int rfftb1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rfftf_(int_4 *n, r_4 *r__, r_4 *wsave);
+extern int rfftf1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rffti_(int_4 *n, r_4 *wsave);
+extern int rffti1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int sinqb_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sinqf_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sinqi_(int_4 *n, r_4 *wsave);
+extern int sint_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sint1_(int_4 *n, r_4 *war, r_4 *was, r_4 *xh, r_4 *x, int_4 *ifac);
+extern int sinti_(int_4 *n, r_4 *wsave);
 
 /* ---------------------- */
 
-extern int cdfftb_(integer *n, r_8 *c__, r_8 *wsave);
-extern int cdfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int cdfftf_(integer *n, r_8 *c__, r_8 *wsave);
-extern int cdfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int cdffti_(integer *n, r_8 *wsave);
-extern int cdffti1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dcosqb_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosqb1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
-extern int dcosqf_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosqf1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
-extern int dcosqi_(integer *n, r_8 *wsave);
-extern int dcost_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosti_(integer *n, r_8 *wsave);
-extern int dezfft1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dezfftb_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
-extern int dezfftf_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
-extern int dezffti_(integer *n, r_8 *wsave);
-extern int dpassb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dpassb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dpassb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dpassb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dpassb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dpassf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dpassf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dpassf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dpassf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dpassf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dadb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dadb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dadb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dadf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dadf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dadf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dadf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dfftb_(integer *n, r_8 *r__, r_8 *wsave);
-extern int dfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int dfftf_(integer *n, r_8 *r__, r_8 *wsave);
-extern int dfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int dffti_(integer *n, r_8 *wsave);
-extern int dffti1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dsinqb_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsinqf_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsinqi_(integer *n, r_8 *wsave);
-extern int dsint_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsint1_(integer *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *x, int_8 *ifac);
-extern int dsinti_(integer *n, r_8 *wsave);
+extern int cdfftb_(int_4 *n, r_8 *c__, r_8 *wsave);
+extern int cdfftb1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdfftf_(int_4 *n, r_8 *c__, r_8 *wsave);
+extern int cdfftf1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdffti_(int_4 *n, r_8 *wsave);
+extern int cdffti1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dcosqb_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosqb1_(int_4 *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqf_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosqf1_(int_4 *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqi_(int_4 *n, r_8 *wsave);
+extern int dcost_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosti_(int_4 *n, r_8 *wsave);
+extern int dezfft1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dezfftb_(int_4 *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezfftf_(int_4 *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezffti_(int_4 *n, r_8 *wsave);
+extern int dpassb_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassb2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassb3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassb4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassb5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dpassf_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassf2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassf3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassf4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassf5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadb2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadb3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadb4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadb5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadbg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dadf2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadf3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadf4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadf5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadfg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dfftb_(int_4 *n, r_8 *r__, r_8 *wsave);
+extern int dfftb1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dfftf_(int_4 *n, r_8 *r__, r_8 *wsave);
+extern int dfftf1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dffti_(int_4 *n, r_8 *wsave);
+extern int dffti1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dsinqb_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsinqf_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsinqi_(int_4 *n, r_8 *wsave);
+extern int dsint_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsint1_(int_4 *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *x, int_8 *ifac);
+extern int dsinti_(int_4 *n, r_8 *wsave);
 
 /* Rerunning f2c -P may change prototypes or declarations. */