Index: unk/SophyaLib/SkyT/HowToUse
===================================================================
--- /trunk/SophyaLib/SkyT/HowToUse	(revision 759)
+++ 	(revision )
@@ -1,53 +1,0 @@
-#!/bin/csh
-if ($#argv < 2)  then
-  echo 'Usage: HowToUse NSide_HealPix OutFITSfile'
-  exit 1
-endif
-
-
-echo '    *************************************************************';
-echo '		creating spectral response powerlaw';
-echo '    *************************************************************';
-echo '  ' 
-set cmd = "tgrsr 1 .2,120,50,-0.7,100,600 200 pl.fits"
-echo ' ' 
-echo 'Executing' $cmd
-time $cmd
-
-echo '	*************************************************************';
-echo '		creating gaussian radiation spectra sky';
-echo '	*************************************************************';
-set cmd = "tgsky $1 0 140,30 gauss.fits"
-echo ' ' 
-echo 'Executing' $cmd
-time $cmd
-
-echo '	*************************************************************';
-echo '		creating cosine/sine radiation spectra  sky';
-echo '	*************************************************************';
-set cmd = "tgsky $1 2 12,7,9,10 cossin.fits"
-echo ' ' 
-echo 'Executing' $cmd
-time $cmd
-
-echo '	*************************************************************';
-echo '		creating noise radiation spectra sky';
-echo '	*************************************************************';
-set cmd = "tgsky $1 1 160,44 noise.fits"
-echo ' ' 
-echo 'Executing' $cmd
-time $cmd
-
-echo '	*************************************************************'
-echo '		calling skymixer'
-echo '	*************************************************************'
-set xx = "@SKYMIX  3  $1"
-echo $xx > test.d
-cat howto.d >> test.d
-
-set cmd = "skymixer test.d $2"
-echo ' ' 
-echo 'Executing' $cmd
-time $cmd
-
-
Index: unk/SophyaLib/SkyT/RSextract.d
===================================================================
--- /trunk/SophyaLib/SkyT/RSextract.d	(revision 759)
+++ 	(revision )
@@ -1,88 +1,0 @@
-#  EXT_RS  NbComponents  NSide_HealPix
-@EXT_RS  31 
-
-#  RD_EXT_PATH  PathForFITS   
-#  path for input Sky Component FITS files , from which the RadSpec
-#  will be extracted
-@RS_EXT_PATH /tmp_mnt/exp/planck/CartesRT/supertango/templates/
-
-#  ----    Sky map for different frequencies        ---------
-#  ----    From which will be extracted the radspectra   ----
-#  RADSPECMAPi FITSfilename freq(MHz)
-@RADSPECMAP1 	eran102_441_00015000mhz.fits
-@RADSPECMAP2 	eran102_441_00018884mhz.fits 
-@RADSPECMAP3 	eran102_441_00023773mhz.fits 
-@RADSPECMAP4	eran102_441_00029929mhz.fits 
-@RADSPECMAP5 	eran102_441_00037678mhz.fits 
-@RADSPECMAP6 	eran102_441_00047434mhz.fits 
-@RADSPECMAP7 	eran102_441_00059716mhz.fits 
-@RADSPECMAP8  	eran102_441_00075178mhz.fits 
-@RADSPECMAP9 	eran102_441_00094644mhz.fits 
-@RADSPECMAP10 	eran102_441_00119149mhz.fits 
-@RADSPECMAP11 	eran102_441_00150000mhz.fits
-@RADSPECMAP12 	eran102_441_00188839mhz.fits	
-@RADSPECMAP13 	eran102_441_00237734mhz.fits	00237734
-@RADSPECMAP14 	eran102_441_00299289mhz.fits 
-@RADSPECMAP15 	eran102_441_00376783mhz.fits
-@RADSPECMAP16 	eran102_441_00474342mhz.fits
-@RADSPECMAP17 	eran102_441_00597161mhz.fits
-@RADSPECMAP18 	eran102_441_00751781mhz.fits
-@RADSPECMAP19 	eran102_441_00946436mhz.fits
-@RADSPECMAP20 	eran102_441_01191492mhz.fits
-@RADSPECMAP21 	eran102_441_01500000mhz.fits	
-@RADSPECMAP22 	eran102_441_01888388mhz.fits	
-@RADSPECMAP23 	eran102_441_02377340mhz.fits
-@RADSPECMAP24 	eran102_441_02992893mhz.fits	
-@RADSPECMAP25 	eran102_441_03767830mhz.fits	
-@RADSPECMAP26 	eran102_441_04743416mhz.fits
-@RADSPECMAP27 	eran102_441_05971608mhz.fits	
-@RADSPECMAP28 	eran102_441_07517809mhz.fits	
-@RADSPECMAP29 	eran102_441_09464360mhz.fits
-@RADSPECMAP30 	eran102_441_11914924mhz.fits		
-@RADSPECMAP31 	eran102_441_15000000mhz.fits
-
-
-#  ----   Source point map for different frequencies        ---------
-#  ----    From which will be extracted the radspectra   ----
-#  SOURCEPTMAPi FITSfilename freq(MHz)
-@SOURCEPTMAP1 	eran102_441_00015000mhz.s_rare
-@SOURCEPTMAP2 	eran102_441_00018884mhz.s_rare
-@SOURCEPTMAP3 	eran102_441_00023773mhz.s_rare
-@SOURCEPTMAP4	eran102_441_00029929mhz.s_rare
-@SOURCEPTMAP5 	eran102_441_00037678mhz.s_rare
-@SOURCEPTMAP6 	eran102_441_00047434mhz.s_rare 
-@SOURCEPTMAP7 	eran102_441_00059716mhz.s_rare 	
-@SOURCEPTMAP8  	eran102_441_00075178mhz.s_rare 
-@SOURCEPTMAP9 	eran102_441_00094644mhz.s_rare 
-@SOURCEPTMAP10 	eran102_441_00119149mhz.s_rare
-@SOURCEPTMAP11 	eran102_441_00150000mhz.s_rare
-@SOURCEPTMAP12 	eran102_441_00188839mhz.s_rare	
-@SOURCEPTMAP13 	eran102_441_00237734mhz.s_rare
-@SOURCEPTMAP14 	eran102_441_00299289mhz.s_rare 
-@SOURCEPTMAP15 	eran102_441_00376783mhz.s_rare	
-@SOURCEPTMAP16 	eran102_441_00474342mhz.s_rare	
-@SOURCEPTMAP17 	eran102_441_00597161mhz.s_rare	
-@SOURCEPTMAP18 	eran102_441_00751781mhz.s_rare
-@SOURCEPTMAP19 	eran102_441_00946436mhz.s_rare
-@SOURCEPTMAP20 	eran102_441_01191492mhz.s_rare
-@SOURCEPTMAP21 	eran102_441_01500000mhz.s_rare
-@SOURCEPTMAP22 	eran102_441_01888388mhz.s_rare
-@SOURCEPTMAP23 	eran102_441_02377340mhz.s_rare
-@SOURCEPTMAP24 	eran102_441_02992893mhz.s_rare
-@SOURCEPTMAP25 	eran102_441_03767830mhz.s_rare
-@SOURCEPTMAP26 	eran102_441_04743416mhz.s_rare	
-@SOURCEPTMAP27 	eran102_441_05971608mhz.s_rare
-@SOURCEPTMAP28 	eran102_441_07517809mhz.s_rare
-@SOURCEPTMAP29 	eran102_441_09464360mhz.s_rare
-@SOURCEPTMAP30 	eran102_441_11914924mhz.s_rare		
-@SOURCEPTMAP31 	eran102_441_15000000mhz.s_rare
-
-
-# Filter definition now !!
-# define the detector (only one)
-@GAUSSFILTER 143 12 0.84 50. 300.
-
-#  ---- wanna print a lot of stuff..---------
-#  ----  let's try PRINTLEVEL 5          ----
-@PRINTLEVEL  0
-
Index: /trunk/SophyaLib/SkyT/exclude
===================================================================
--- /trunk/SophyaLib/SkyT/exclude	(revision 759)
+++ /trunk/SophyaLib/SkyT/exclude	(revision 760)
@@ -1,5 +1,0 @@
-extractRS.cc
-easyTest.cc
-tgrsr.cc
-tgsky.cc
-skymixer.cc
Index: unk/SophyaLib/SkyT/howto.d
===================================================================
--- /trunk/SophyaLib/SkyT/howto.d	(revision 759)
+++ 	(revision )
@@ -1,47 +1,0 @@
-#  SKYMIX  NbComponents  NSide_HealPix
-SKYMIX  3  128
-
-#  READMAP  FitsName
-#  To Read the already prepared (mixed) Output MAP from FITS file
-#  FitsName should be the complete path to the FITS file
-READMAP xxx.fits
-
-#  Defining the Detection filter pass - band
-#  GAUSSFILTER or FILTERFITSFILE  card
-#  GAUSSFILTER -> Gaussian filter
-#  FILTERFITSFILE -> Filter (nu, T(nu)) from FITS file
-#  GAUSSFILTER  Nu0 Sigma_Nu Tmax NuMin NuMax
-#  FILTERFITSFILE FileName NuMin NuMax
-#       FileName should be a complete path
-@GAUSSFILTER 143 12 0.84 50. 300.
-
-#  MAPPATH  PathForFITS   
-#  path for input Sky Component FITS files , and EmissionSpectra files 
-MAPPATH /data/opus/Rz/SOPHYA/
-
-
-#  ----        Sky components  ---------
-#      ----     HealPix maps   ----
-#  MAPFITSFILEi FITSfilename Normalisation
-@MAPFITSFILE1  gauss.fits  1.0 
-
-#      ---   Emission Spectra definition -----
-#   SPECTRAFITSFILEi  FITSfilename  Fmin Fmax 
-@SPECTRAFITSFILE1  pl.fits 100 600  
-
-#   Other possible definition of emission spectra
-#   BLACKBODYi  temperature
-#  The blackbody object returns flux in units of watt/m2/sr/hz
-#   We thus scale the map (x 1.e17) 
-@MAPFITSFILE2  cossin.fits  1.e17 
-@BLACKBODY2 2.726
-
-#   For power-law spectra  f = a ((nu-nu0)/dnu)^b)
-#   POWERLAWSPECTRAi  a nu0 dnu b Fmin Fmax
-@MAPFITSFILE3  noise.fits    0.1 
-@POWERLAWSPECTRA3 1. 150. 50. -0.5 100. 500.
-
-#  Define the Debug level
-@DEBUGLEVEL  0
-#  Define the Print level
-@PRINTLEVEL  5
Index: unk/SophyaLib/SkyT/skm.d
===================================================================
--- /trunk/SophyaLib/SkyT/skm.d	(revision 759)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#  SKYMIX  NbComponents  NSide_HealPix
-@SKYMIX  2  64
-
-#  READMAP  FitsName
-#  To Read the already prepared (mixed) Output MAP from FITS file
-#  FitsName should be the complete path to the FITS file
-READMAP xxx.fits
-
-#  Defining the Detection filter pass - band
-#  GAUSSFILTER or FILTERFITSFILE  card
-#  GAUSSFILTER -> Gaussian filter
-#  FILTERFITSFILE -> Filter (nu, T(nu)) from FITS file
-#  GAUSSFILTER  Nu0 Sigma_Nu Tmax NuMin NuMax
-#  FILTERFITSFILE FileName NuMin NuMax
-#       FileName should be a complete path
-@GAUSSFILTER 143 12 0.84 50. 300.
-
-#  MAPPATH  PathForFITS   
-#  path for input Sky Component FITS files , and EmissionSpectra files 
-MAPPATH /exp/eros/Reza/CartesRT
-
-
-#  ----        Sky components  ---------
-#      ----     HealPix maps   ----
-#  MAPFITSFILEi FITSfilename Normalisation
-@MAPFITSFILE1  map_essai.fits  1.0 
-@MAPFITSFILE2    comp2.fits    0.25 
-
-#      ---   Emission Spectra definition -----
-#   SPECTRAFITSFILEi  FITSfilename  Fmin Fmax 
-@SPECTRAFITSFILE1  spec1.fits  
-
-#   Other possible definition of emission spectra
-#   BLACKBODYi  temperature
-BLACKBODY1 2.726
-#   For power-law spectra  f = a ((nu-nu0)/dnu)^b)
-#   POWERLAWSPECTRAi  a nu0 dnu b Fmin Fmax
-POWERLAWSPECTRA1 1. 150. 50. -0.5 100. 500.
-
-#  Define the Debug level
-@DEBUGLEVEL  0
-#  Define the Print level
-@PRINTLEVEL  0